/*
 * This file is generated by jOOQ.
 */
package ajar.ieds.calc.api.sql.tables.records;


import ajar.ieds.calc.api.sql.tables.Expression;
import ajar.ieds.calc.api.sql.tables.pojos.JooqExpression;

import jakarta.validation.constraints.Size;

import java.time.LocalDateTime;

import javax.annotation.processing.Generated;

import org.jooq.Field;
import org.jooq.Record1;
import org.jooq.Record6;
import org.jooq.Row6;
import org.jooq.impl.UpdatableRecordImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "https://www.jooq.org",
        "jOOQ version:3.18.4",
        "schema version:1"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class ExpressionRecord extends UpdatableRecordImpl<ExpressionRecord> implements Record6<Long, String, String, LocalDateTime, LocalDateTime, String> {

    private static final long serialVersionUID = 1L;

    /**
     * Setter for <code>expression.expression_id</code>.
     */
    public void setExpressionId(Long value) {
        set(0, value);
    }

    /**
     * Getter for <code>expression.expression_id</code>.
     */
    public Long getExpressionId() {
        return (Long) get(0);
    }

    /**
     * Setter for <code>expression.name</code>.
     */
    public void setName(String value) {
        set(1, value);
    }

    /**
     * Getter for <code>expression.name</code>.
     */
    @Size(max = 20)
    public String getName() {
        return (String) get(1);
    }

    /**
     * Setter for <code>expression.expression</code>.
     */
    public void setExpression(String value) {
        set(2, value);
    }

    /**
     * Getter for <code>expression.expression</code>.
     */
    public String getExpression() {
        return (String) get(2);
    }

    /**
     * Setter for <code>expression.created_at</code>.
     */
    public void setCreatedAt(LocalDateTime value) {
        set(3, value);
    }

    /**
     * Getter for <code>expression.created_at</code>.
     */
    public LocalDateTime getCreatedAt() {
        return (LocalDateTime) get(3);
    }

    /**
     * Setter for <code>expression.modified_at</code>.
     */
    public void setModifiedAt(LocalDateTime value) {
        set(4, value);
    }

    /**
     * Getter for <code>expression.modified_at</code>.
     */
    public LocalDateTime getModifiedAt() {
        return (LocalDateTime) get(4);
    }

    /**
     * Setter for <code>expression.author</code>.
     */
    public void setAuthor(String value) {
        set(5, value);
    }

    /**
     * Getter for <code>expression.author</code>.
     */
    @Size(max = 20)
    public String getAuthor() {
        return (String) get(5);
    }

    // -------------------------------------------------------------------------
    // Primary key information
    // -------------------------------------------------------------------------

    @Override
    public Record1<Long> key() {
        return (Record1) super.key();
    }

    // -------------------------------------------------------------------------
    // Record6 type implementation
    // -------------------------------------------------------------------------

    @Override
    public Row6<Long, String, String, LocalDateTime, LocalDateTime, String> fieldsRow() {
        return (Row6) super.fieldsRow();
    }

    @Override
    public Row6<Long, String, String, LocalDateTime, LocalDateTime, String> valuesRow() {
        return (Row6) super.valuesRow();
    }

    @Override
    public Field<Long> field1() {
        return Expression.EXPRESSION.EXPRESSION_ID;
    }

    @Override
    public Field<String> field2() {
        return Expression.EXPRESSION.NAME;
    }

    @Override
    public Field<String> field3() {
        return Expression.EXPRESSION.EXPRESSION_;
    }

    @Override
    public Field<LocalDateTime> field4() {
        return Expression.EXPRESSION.CREATED_AT;
    }

    @Override
    public Field<LocalDateTime> field5() {
        return Expression.EXPRESSION.MODIFIED_AT;
    }

    @Override
    public Field<String> field6() {
        return Expression.EXPRESSION.AUTHOR;
    }

    @Override
    public Long component1() {
        return getExpressionId();
    }

    @Override
    public String component2() {
        return getName();
    }

    @Override
    public String component3() {
        return getExpression();
    }

    @Override
    public LocalDateTime component4() {
        return getCreatedAt();
    }

    @Override
    public LocalDateTime component5() {
        return getModifiedAt();
    }

    @Override
    public String component6() {
        return getAuthor();
    }

    @Override
    public Long value1() {
        return getExpressionId();
    }

    @Override
    public String value2() {
        return getName();
    }

    @Override
    public String value3() {
        return getExpression();
    }

    @Override
    public LocalDateTime value4() {
        return getCreatedAt();
    }

    @Override
    public LocalDateTime value5() {
        return getModifiedAt();
    }

    @Override
    public String value6() {
        return getAuthor();
    }

    @Override
    public ExpressionRecord value1(Long value) {
        setExpressionId(value);
        return this;
    }

    @Override
    public ExpressionRecord value2(String value) {
        setName(value);
        return this;
    }

    @Override
    public ExpressionRecord value3(String value) {
        setExpression(value);
        return this;
    }

    @Override
    public ExpressionRecord value4(LocalDateTime value) {
        setCreatedAt(value);
        return this;
    }

    @Override
    public ExpressionRecord value5(LocalDateTime value) {
        setModifiedAt(value);
        return this;
    }

    @Override
    public ExpressionRecord value6(String value) {
        setAuthor(value);
        return this;
    }

    @Override
    public ExpressionRecord values(Long value1, String value2, String value3, LocalDateTime value4, LocalDateTime value5, String value6) {
        value1(value1);
        value2(value2);
        value3(value3);
        value4(value4);
        value5(value5);
        value6(value6);
        return this;
    }

    // -------------------------------------------------------------------------
    // Constructors
    // -------------------------------------------------------------------------

    /**
     * Create a detached ExpressionRecord
     */
    public ExpressionRecord() {
        super(Expression.EXPRESSION);
    }

    /**
     * Create a detached, initialised ExpressionRecord
     */
    public ExpressionRecord(Long expressionId, String name, String expression, LocalDateTime createdAt, LocalDateTime modifiedAt, String author) {
        super(Expression.EXPRESSION);

        setExpressionId(expressionId);
        setName(name);
        setExpression(expression);
        setCreatedAt(createdAt);
        setModifiedAt(modifiedAt);
        setAuthor(author);
        resetChangedOnNotNull();
    }

    /**
     * Create a detached, initialised ExpressionRecord
     */
    public ExpressionRecord(JooqExpression value) {
        super(Expression.EXPRESSION);

        if (value != null) {
            setExpressionId(value.getExpressionId());
            setName(value.getName());
            setExpression(value.getExpression());
            setCreatedAt(value.getCreatedAt());
            setModifiedAt(value.getModifiedAt());
            setAuthor(value.getAuthor());
            resetChangedOnNotNull();
        }
    }
}
